#include <QTabWidget>
#include <QLineEdit>
#include <QLayout>
#include <QApplication>

class MyWidget : public QWidget
{
public:
  MyWidget ()
    : QWidget (0)
  {
    new QVBoxLayout (this);
  }

  void setN (int n)
  {
    _n = n;
  }

  virtual void showEvent (QShowEvent *)
  {
    for (int i = 0; i < _n; ++i)
      {
	QLineEdit *le = new QLineEdit (this);
	layout ()->addWidget (le);
	_les.append (le);
      }
  }

  virtual void hideEvent (QHideEvent *)
  {
    qDeleteAll (_les);
    _les.clear ();
  }

private:
  int _n;
  QList<QLineEdit*> _les;
};


int main (int argc, char **argv)
{
  QApplication app (argc, argv);

  QTabWidget *tw = new QTabWidget;
  
  MyWidget *w1 = new MyWidget;
  w1->setN (5);
  
  MyWidget *w2 = new MyWidget;
  w2->setN (5);

  tw->addTab (w1, "1");
  tw->addTab (w2, "2");

  tw->resize (200, 200);
  tw->show ();

  return app.exec ();
}
